Parameters: 
    GraylogElasticsearchName:
         Type: String
         Default: es-graylog
    GraylogElasticsearchInstancetype:
         Type: String
         Default: "t2.small.elasticsearch"
         Description: Size of elasticsearch instances
    GraylogElasticsearchInstancecount:
         Type: Number
         Default: 3
         MinValue: 1
         MaxValue: 10 
         Description: Number of ElasticSearchInstances
    GraylogElasticsearchZoneawareness:
        Type: String
        Default: False
        Description: Whether ElasticSearch is Zone Aware
    GraylogElasticsearchVersion:
        Type: String
        Default: 5.5
        Description: ElasticSearch version. Note that at July 2018 Graylog does not support version 6.x
    GraylogLaunchconfigAssociatepublicipaddress:
        Type: String
        Default: True
        Description: Whether individual instances get public IP
    GraylogLaunchconfigEbsoptimized:
        Type: String
        Default: False
        Description: Whether EbsOptimized is used. Probably not required
    GraylogLaunchconfigImageid:
        Type: AWS::EC2::Image::Id
        Default: ami-67589505
        Description: The ID of the AMI to be used. This Cloudformation will expect Red Hat/CentOS/Amazon Linux
    GraylogLaunchconfigInstancemonitoring:
        Type: String
        Default: False
        Description: Whether to setup CloudWatch monitoring. Suggest to do this for production
    GraylogLaunchconfigInstancetype:
        Type: String
        Default: t2.small
    GraylogLaunchconfigKeyname:
        Type: AWS::EC2::KeyPair::KeyName
        Description: SSH Key to use
    GraylogLaunchconfigSecuritygroupsshcidrip:
        Type: String
        Default: 0.0.0.0/0
        Description: IP address range that needs to be able to SSH
    GraylogLbHealthythreshold:
        Type: Number
        Default: 2
        MinValue: 1
        MaxValue: 5
        Description: Loadbalancer Number of checks before instance is considered healthy
    GraylogLbIdletimeout:
        Type: Number
        Default: 60 
        MinValue: 20
        MaxValue: 300
        Description: Load Balancer timeout on Idle Connections
    GraylogLbInterval:
        Type: Number
        Default: 30
        MinValue: 5
        MaxValue: 300
        Description: Health Check Interval
    GraylogLbScheme:
        Type: String
        Default: internet-facing
        AllowedValues: 
           - internet-facing
           - internal
        Description: Loadbalancer scheme
    GraylogLbTarget:
        Type: String
        Default: HTTP:80/api/system/lbstatus 
        Description: Target of loadbalancer
    GraylogLbTimeout:
        Type: Number
        Default: 5
        MinValue: 2
        MaxValue: 30
        Description: Load Balancer Connection Failure Timeout
    GraylogLbUnhealhtyThreshold:
        Type: Number
        Default: 2
        MinValue: 1
        MaxValue: 5
        Description: Number of unhealthy checks to mark instance as unhealhy
Resources:
    securitygroupstack:
       Type: 'AWS::CloudFormation::Stack'
       Properties:
          Parameters:
              GraylogLaunchconfigSecuritygroupsshcidrip: !Ref GraylogLaunchconfigSecuritygroupsshcidrip
              GraylogVpc: !ImportValue cfvpc-VPC
          TemplateURL: "{{cf_security.url}}"
          TimeoutInMinutes: '10'
    elasticsearchstack:
       Type: 'AWS::CloudFormation::Stack'
       Properties:
          Parameters:
             GraylogElasticsearchInstancetype: !Ref GraylogElasticsearchInstancetype
             GraylogElasticsearchInstancecount: !Ref GraylogElasticsearchInstancecount
             GraylogElasticsearchZoneawareness: !Ref GraylogElasticsearchZoneawareness
             GraylogElasticsearchVersion: !Ref GraylogElasticsearchVersion
             GraylogLaunchconfigSecuritygroup: !GetAtt securitygroupstack.Outputs.GraylogLaunchconfigSecuritygroup
             GraylogSubnet1: !ImportValue cfvpc-PubSubnet1
             GraylogSubnet2: !ImportValue cfvpc-PubSubnet2
             GraylogSubnet3: !ImportValue cfvpc-PubSubnet3
          TemplateURL: "{{cf_elasticsearch.url}}"
          TimeoutInMinutes: '30'
    mongostack:
       Type: 'AWS::CloudFormation::Stack'
       Properties:
          Parameters:
             GraylogLaunchconfigSecuritygroup: !GetAtt securitygroupstack.Outputs.GraylogLaunchconfigSecuritygroup
             GraylogSubnet1: !ImportValue cfvpc-PubSubnet1
             GraylogSubnet2: !ImportValue cfvpc-PubSubnet2
             GraylogSubnet3: !ImportValue cfvpc-PubSubnet3
             MongoLaunchconfigKeyname: !Ref GraylogLaunchconfigKeyname
          TemplateURL: "{{cf_mongo.url}}"
          TimeoutInMinutes: '30'
    graylogstack:
       Type: 'AWS::CloudFormation::Stack'
       DependsOn: 
              - mongostack 
              - elasticsearchstack
       Properties:
          Parameters:
             GraylogLaunchconfigSecuritygroup: !GetAtt securitygroupstack.Outputs.GraylogLaunchconfigSecuritygroup
             GraylogLbSecuritygroup: !GetAtt securitygroupstack.Outputs.GraylogLbSecuritygroup
             GraylogSubnet1: !ImportValue cfvpc-PubSubnet1
             GraylogSubnet2: !ImportValue cfvpc-PubSubnet2
             GraylogSubnet3: !ImportValue cfvpc-PubSubnet3
             GraylogLbScheme: !Ref GraylogLbScheme
             GraylogLaunchconfigImageid: !Ref GraylogLaunchconfigImageid
             GraylogLaunchconfigKeyname: !Ref GraylogLaunchconfigKeyname
             GraylogLaunchconfigAssociatepublicipaddress: !Ref GraylogLaunchconfigAssociatepublicipaddress
             GraylogLaunchconfigEbsoptimized: !Ref GraylogLaunchconfigEbsoptimized
             GraylogLaunchconfigInstancemonitoring: !Ref  GraylogLaunchconfigInstancemonitoring
             GraylogLaunchconfigInstancetype: !Ref GraylogLaunchconfigInstancetype
             GraylogLbHealthythreshold:  !Ref GraylogLbHealthythreshold
             GraylogLbIdletimeout: !Ref GraylogLbIdletimeout
             GraylogLbInterval: !Ref GraylogLbInterval
             GraylogLbTarget: !Ref GraylogLbTarget
             GraylogLbTimeout: !Ref  GraylogLbTimeout
             GraylogLbUnhealhtyThreshold: !Ref GraylogLbUnhealhtyThreshold
             GraylogElasticsearch: !GetAtt elasticsearchstack.Outputs.GraylogElasticsearch
          TemplateURL: "{{cf_graylog.url}}"
          TimeoutInMinutes: '30'

   
   
